#!/bin/sh
. common

checkbox()
{
 # NAME, current RELATED, current ESTABLISHED 
  echo "<tr><td>Accepted states for $1</td>" 
  if [ "${2}" == "Yes" ]; then
    related=selected
  else
    related=""
  fi
  if [ "${3}" == "Yes" ]; then
    established=selected
  else
    established=""
  fi
  echo "<td>RELATED <input type=checkbox name=\"default=${1}_RELATED\" ${related}></td>"
  echo "<td>ESTABLISHED <input type=checkbox name=\"default=${1}_ESTABLISHED\" ${established}></td></tr>"
}

dropdown()
{
  echo "<tr><td colspan=2>${1}</td>"
  shift
  echo "<td><select name=\"default=${1}\">"
  shift
  current=$1
  shift
  for i in $@
  do
    if [ "${i}" == "${current}" ]; then
      sel="selected"
    else
      sel=""
    fi
    echo "<option ${sel} value=${i}>${i}</option>"
  done
  echo "</td></tr>"
}

select_yn()
{
  echo "<tr><td>${1}</td>"
  echo "<td><select name=${1}>"
  for i in Yes No
  do
    if [ "${i}" == "${2}" ]; then
      sel="selected"
    else
      sel=""
    fi
    echo "<option ${sel} value=${i}>${i}</option>"
  done
  echo "</td></tr>"
}


header Defaults

QS=`cat -`

# Start by reading in the current settings ...
grep "^default=" ${CFG} |cut -d"=" -f2- > ${TMP}
grep "_RELATED=" ${CFG} >> ${TMP}
grep "_ESTABLISHED=" ${CFG} >> ${TMP}
. ${TMP}

# Now see what we've been told ...
./hex2env "${QS}" > /tmp/c.txt
./hex2env "${QS}" |cut -d"=" -f2- > ${TMP}
cp ${TMP} /tmp/a.txt
grep "Make Changes" ${TMP} > /dev/null 2>&1
if [ "$?" -eq "0" ]; then
  . ${TMP}
  set > /tmp/b.txt
  grep -v "^default=" ${CFG} |grep -v "_RELATED=" |grep -v "_ESTABLISHED=" > ${TMP}
  mv ${TMP} ${CFG}
  # Checkboxes aren't on/off, they're just "there" as \"\" if they've been selected...
  grep "INPUT_RELATED" ${TMP} > /dev/null 2>&1
  if [ "$?" -eq "0" ]; then
    INPUT_RELATED="Yes"
  grep "INPUT_ESTABLISHED" ${TMP} > /dev/null 2>&1
  if [ "$?" -eq "0" ]; then
    INPUT_ESTABLISHED="Yes"
  grep "OUTPUT_RELATED" ${TMP} > /dev/null 2>&1
  if [ "$?" -eq "0" ]; then
    OUTPUT_RELATED="Yes"
  grep "OUTPUT_ESTABLISHED" ${TMP} > /dev/null 2>&1
  if [ "$?" -eq "0" ]; then
    OUTPUT_ESTABLISHED="Yes"
  grep "FORWARD_RELATED" ${TMP} > /dev/null 2>&1
  if [ "$?" -eq "0" ]; then
    FORWARD_RELATED="Yes"
  grep "FORWARD_ESTABLISHED" ${TMP} > /dev/null 2>&1
  if [ "$?" -eq "0" ]; then
    FORWARD_ESTABLISHED="Yes"
  fi
  echo "default=INPUT=$INPUT" >> ${CFG}
  echo "INPUT_RELATED=${INPUT_RELATED}" >> ${CFG}
  echo "INPUT_ESTABLISHED=${INPUT_ESTABLISHED}" >> ${CFG}
  echo "default=OUTPUT=$OUTPUT" >> ${CFG}
  echo "OUTPUT_RELATED=${OUTPUT_RELATED}" >> ${CFG}
  echo "OUTPUT_ESTABLISHED=${OUTPUT_ESTABLISHED}" >> ${CFG}
  echo "default=FORWARD=$FORWARD" >> ${CFG}
  echo "FORWARD_RELATED=${FORWARD_RELATED}" >> ${CFG}
  echo "FORWARD_ESTABLISHED=${FORWARD_ESTABLISHED}" >> ${CFG}
  echo "default=modprobe=$modprobe" >> ${CFG}
  echo "default=IPFW=$IPFW" >> ${CFG}
  echo "default=DynAddr=$DynAddr" >> ${CFG}
fi

#rm -f ${TMP}

echo "<form action=\"defaults.cgi\" method=post>"
echo "<table border=1>"
dropdown "Default rule for INPUT chain" INPUT $INPUT ACCEPT REJECT DROP DENY FORWARD REDIRECT
checkbox INPUT $INPUT_RELATED $INPUT_ESTABLISHED
dropdown "Default rule for OUTPUT chain" OUTPUT $OUTPUT ACCEPT REJECT DROP DENY FORWARD REDIRECT
checkbox OUTPUT $OUTPUT_RELATED $OUTPUT_ESTABLISHED
dropdown "Default rule for FORWARD chain" FORWARD $FORWARD ACCEPT REJECT DROP DENY FORWARD REDIRECT
checkbox FORWARD $FORWARD_RELATED $FORWARD_ESTABLISHED
dropdown "Kernel Modules" modprobe $modprobe Modular Monolithic
dropdown "IP Forwarding" IPFW $IPFW Yes No
dropdown "Dynamic IP Address" DynAddr $DynAddr Yes No
echo "<tr><td><input type=submit name="makechanges" value=\"Make Changes\"></td>"
echo "<td><input type=reset></td></tr>"
echo "</table>"
echo "</form>"

footer
